// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from automotive_navigation_msgs:msg/PointOfInterest.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST__TRAITS_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "automotive_navigation_msgs/msg/detail/point_of_interest__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace automotive_navigation_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PointOfInterest & msg,
  std::ostream & out)
{
  out << "{";
  // member: guid
  {
    out << "guid: ";
    rosidl_generator_traits::value_to_yaml(msg.guid, out);
    out << ", ";
  }

  // member: latitude
  {
    out << "latitude: ";
    rosidl_generator_traits::value_to_yaml(msg.latitude, out);
    out << ", ";
  }

  // member: longitude
  {
    out << "longitude: ";
    rosidl_generator_traits::value_to_yaml(msg.longitude, out);
    out << ", ";
  }

  // member: params
  {
    out << "params: ";
    rosidl_generator_traits::value_to_yaml(msg.params, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PointOfInterest & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: guid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "guid: ";
    rosidl_generator_traits::value_to_yaml(msg.guid, out);
    out << "\n";
  }

  // member: latitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "latitude: ";
    rosidl_generator_traits::value_to_yaml(msg.latitude, out);
    out << "\n";
  }

  // member: longitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "longitude: ";
    rosidl_generator_traits::value_to_yaml(msg.longitude, out);
    out << "\n";
  }

  // member: params
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "params: ";
    rosidl_generator_traits::value_to_yaml(msg.params, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PointOfInterest & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace automotive_navigation_msgs

namespace rosidl_generator_traits
{

[[deprecated("use automotive_navigation_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const automotive_navigation_msgs::msg::PointOfInterest & msg,
  std::ostream & out, size_t indentation = 0)
{
  automotive_navigation_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use automotive_navigation_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const automotive_navigation_msgs::msg::PointOfInterest & msg)
{
  return automotive_navigation_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<automotive_navigation_msgs::msg::PointOfInterest>()
{
  return "automotive_navigation_msgs::msg::PointOfInterest";
}

template<>
inline const char * name<automotive_navigation_msgs::msg::PointOfInterest>()
{
  return "automotive_navigation_msgs/msg/PointOfInterest";
}

template<>
struct has_fixed_size<automotive_navigation_msgs::msg::PointOfInterest>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<automotive_navigation_msgs::msg::PointOfInterest>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<automotive_navigation_msgs::msg::PointOfInterest>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST__TRAITS_HPP_
